// Word Rotator
(function (theme, $) {

    theme = theme || {};

    var instanceName = '__wordRotator';

    var PluginWordRotator = function ($el, opts) {
        return this.initialize($el, opts);
    };

    PluginWordRotator.defaults = {
        delay: 2000
    };

    PluginWordRotator.prototype = {
        initialize: function ($el, opts) {
            if ($el.data(instanceName)) {
                return this;
            }

            this.$el = $el;

            this
                .setData()
                .setOptions(opts)
                .build();

            return this;
        },

        setData: function () {
            this.$el.data(instanceName, this);

            return this;
        },

        setOptions: function (opts) {
            this.options = $.extend(true, {}, PluginWordRotator.defaults, opts, {
                wrapper: this.$el
            });

            return this;
        },

        build: function () {
            var $el = this.options.wrapper,
                itemsWrapper = $el.find(".wort-rotator-items"),
                items = itemsWrapper.find("> span"),
                firstItem = items.eq(0),
                firstItemClone = firstItem.clone(),
                itemHeight = firstItem.height(),
                currentItem = 1,
                currentTop = 0;

            console.log("wird", itemsWrapper);

            itemsWrapper.append(firstItemClone);

            $el
                .height(itemHeight)
                .addClass("active");

            setInterval(function () {

                currentTop = (currentItem * itemHeight);

                itemsWrapper.animate({
                    top: -(currentTop) + "px"
                }, 300, function () {

                    currentItem++;

                    if (currentItem > items.length) {

                        itemsWrapper.css("top", 0);
                        currentItem = 1;

                    }

                });

            }, this.options.delay);

            return this;
        }
    };

    // expose to scope
    $.extend(theme, {
        PluginWordRotator: PluginWordRotator
    });

    // jquery plugin
    $.fn.themePluginWordRotator = function (opts) {
        return this.each(function () {
            var $this = $(this);

            if ($this.data(instanceName)) {
                return $this.data(instanceName);
            } else {
                return new PluginWordRotator($this, opts);
            }

        });
    }

}).apply(this, [ window.theme, jQuery ]);