<?php /* VS ver.2024 SetGlobals */

	date_default_timezone_set("Europe/Sofia");
/*
	if(isset($_SERVER['CI_ENV']) and ($_SERVER['CI_ENV']=='BiSOFT' or $_SERVER['CI_ENV']=='development'))
		{ define('ENVIRONMENT', 'development');}
	else 
		{ define('ENVIRONMENT', 'production');}
*/

define('ENVIRONMENT', 'development');

	switch (ENVIRONMENT)
	{
		case 'development':
			error_reporting(-1);
			ini_set('display_errors', 1);
		break;

		case 'testing':
		case 'production':
			ini_set('display_errors', 0);
			if (version_compare(PHP_VERSION, '5.3', '>='))
				{ error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT & ~E_USER_NOTICE & ~E_USER_DEPRECATED); }
			else
				{ error_reporting(E_ALL & ~E_NOTICE & ~E_STRICT & ~E_USER_NOTICE); }
		break;

		default:
			header('HTTP/1.1 503 Service Unavailable.', TRUE, 503);
			echo 'The application environment is not set correctly.';
			exit(1); // EXIT_ERROR
	}
		
	$system_path = 'system';
	$application_folder = 'application';
	$view_folder = '';

	// define HTTPs:
	if(isset($_SERVER['HTTPS']) and $_SERVER['HTTPS']=="on")
		{ define('HTTPSSL', 'https://'. $_SERVER['HTTP_HOST'].'/' ); }
	else
		{ define('HTTPSSL', 'http://'. $_SERVER['HTTP_HOST'].'/' ); }

   // set Language
   $lang = "bg";
   if(isset($_GET['l'])) { $lang = $_GET['l']; if($lang=='el') { $lang = 'gr'; } }

	/*	Geo locator, if needed */
	$inEU = 1; // в Европа сме ?!
	$geo_lang = $lang;

	$ip = $_SERVER['REMOTE_ADDR'];
	$ip_uri = $_SERVER['REQUEST_URI'];
	if($ip_uri==="/")
	{ 
		$host_link = $_SERVER['HTTP_HOST'];
		if($host_link == "vilistil.com") { header("Location: https://vilistil.com/bg/home",true,301); die(); }

		$geo_lang = 'bg';
//    $geo_lang = 'en';

//		$ip = "78.130.146.130";   // BG		
//		$ip = "109.68.151.250";   // GR
//		$ip = "103.249.70.255";   // RO
//		$ip = "5.179.63.255";     // IE

//		$ip = "2.103.255.15";     // GB
//		$ip = "2.95.255.204";     // RU
//    $ip = "5.58.255.145";     // UA
//		$ip = "23.29.223.251";    // CA
		
		if(!isset($lang))
		{
         // get geo location
         $geo = @unserialize(file_get_contents('http://www.geoplugin.net/php.gp?ip='.$ip));
         if($geo and $ip!="127.0.0.1" and $ip!="::1") 
         { 
            $inEU = $geo['geoplugin_inEU'];
            if($inEU)
            {
               $geo_lang = strtolower($geo['geoplugin_countryCode']);
               if($geo_lang=='bg' or $geo_lang=='gr' or $geo_lang=='ro') { $lang = strtoupper($geo_lang); }
               else { $lang = 'EN'; $geo_lang = 'en'; } // всички други само EN
            }
            else { $lang = 'EN'; $geo_lang = 'en'; $inEU = 0; }
         }
			else { $lang = "BG"; $geo_lang = 'bg'; }
      // else { $lang = "EN"; $geo_lang = 'en'; }
      }     

      // if($geo_lang=="bg") { header("Location: https://styler.bg/bg/home");die(); }
      header("Location: ".HTTPSSL."$geo_lang/home");
      die();
   }
   elseif($ip_uri=='/bg' or $ip_uri=='/en')
   {
      // if($ip_uri=='/bg') { header("Location: https://styler.bg/bg/home");die(); }
      $geo_lang = substr($ip_uri,-2);
      header("Location: ".HTTPSSL."$geo_lang/home");
      die();
   }
   else
   { $geo_lang = 'bg'; }
	
	// ново
	if(!isset($bot)) { $bot=0; }
	if(!$inEU) { header("Location: https://google.com");die(); }
	if(!isset($lang)) { $lang = 'en'; }

	$php_OS  = strtoupper(PHP_OS);
//	if($php_OS=='LINUX') { $docRoot = "/var/www/html"; }
//	else { $docRoot = $_SERVER['DOCUMENT_ROOT']; } // само MacOSX // (string)getcwd();

	$docRoot = $_SERVER['DOCUMENT_ROOT'];
	
	// finally define LANG & CNTR
	if(!defined('LANG')) define('LANG', strtoupper($lang));
	if(!defined('CNTR')) define('CNTR', strtoupper($geo_lang));
	
   // set special dirs:
	if(!defined('MAINDIR')) define('MAINDIR', HTTPSSL.'vs/');
	if($php_OS=='LINUX') { if(!defined('ROOTDIR')) { define('ROOTDIR', HTTPSSL);} }
	else { if(!defined('ROOTDIR')) define('ROOTDIR', 'http://localhost/'); } // за др. MacOSX

	// sets for locals
	if($ip=="127.0.0.1" or $ip=="127.0.1.1" or $ip=="127.0.2.1" or $ip=="127.0.3.1" or $ip=="::1")
	{  //	localhost
		define('STRHTTP', 'http://localhost/');
		// change lang modes
		if(!defined('BGDIR')) define('BGDIR', 'http://localhost/');
		if(!defined('ENDIR')) define('ENDIR', 'http://localhost/');
	}
	else
	{  // for Server
		if(LANG=='BG') { define('STRHTTP', 'https://vilistil.com/' ); }
		else  { define('STRHTTP', 'https://vilistil.com/' ); }
			// change lang modes
		if(!defined('BGDIR')) define('BGDIR', 'https://vilistil.com/');
		if(!defined('ENDIR')) define('ENDIR', 'https://vilistil.com/');
	}

	$lng = strtolower(LANG);
	$host_link = $_SERVER['HTTP_HOST'];

	// let's define GLOBALs
	if(!defined('STRDIR'))		define('STRDIR',   "$docRoot/vs/");
	if(!defined('CMDIR'))		define('CMDIR',    "$docRoot/vs/cmd/");
	if(!defined('SYSDIR'))		define('SYSDIR',   "$docRoot/vs/sys/");
	if(!defined('PGSDIR'))		define('PGSDIR',   "$docRoot/vs/pgs/");
	if(!defined('VOCDIR'))		define('VOCDIR',   "$docRoot/vs/vocs/");
	if(!defined('STRDATA'))		define('STRDATA',  "$docRoot/vsdata/$lng/");
	
	if(!defined('SIZEIMG'))		define('SIZEIMG',  MAINDIR."images/size_guides/");
	if(!defined('IMGDIR'))		define('IMGDIR' ,  MAINDIR."images/");
	
	if(!defined('GAMESDIR'))	define('GAMESDIR', STRDATA."games/");
	if(!defined('BLOGDIR'))		define('BLOGDIR',  ROOTDIR."$lng/blogs/");
	if(!defined('BLOGIMG'))		define('BLOGIMG',  ROOTDIR."strdata/$lng/blogs/images/");
	
	// BiSOFT
	if(!defined('BISOFTDIR'))
	{
		if($ip=="127.0.0.1" or $ip=="127.0.1.1" or $ip=="127.0.2.1" or $ip=="127.0.3.1" or $ip=="::1")
		{ define('BISOFTDIR', 'http://localhost/'); }
		else { define('BISOFTDIR', HTTPSSL); }
	}

	if(!defined('DIRPICS')) { define('DIRPICS', ROOTDIR.'vsdata/online_shop/pictures/'); }
   if(!defined('EURO10')) { define('EURO10', 1.778027); }

   // My Globals
	$mainDir = "$docRoot/vs";
	$sysDir  = "$docRoot/vs/sys";
	$pgsDir  = "$docRoot/vs/pgs";
	$vocDir  = "$docRoot/vs/vocs";
	$blogDir = "$docRoot/vsdata/$lng/blogs";
	$strData = "$docRoot/vsdata/$lng";
	
	// backup dir:
	$backData = "$docRoot/vs/pgs/backup";
	if(!defined('BACKDATA')) { define('BACKDATA', "$backData/"); }
	
	$imgDir    = ROOTDIR."vsdata/$lng/images";
	$bxogDir   = ROOTDIR."vsdata/online_shop/images/bxog";
	$storeDir  = ROOTDIR."vsdata/online_shop/images";
	$pathImage = "$docRoot/vsdata/$lng/images";
	$videoDir  = ROOTDIR."vsdata/$lng/videos";
	$cmdDir    = ROOTDIR."$lng/cmd";
	$cssDir    = MAINDIR."assets/css";

	// започваме ... // chdir($docRoot);
	$lic_date = strtotime(date('Y-m-d'));
	$bisoft_license = substr(md5("BiSOFT-$lic_date"),3,13);

	require_once("$docRoot/bisoft/online/vsfuncs.php");
	require_once("$docRoot/vs/sys/funcs.php");
?>
